#ifndef TARTANALOOP_HH
#define TARTANALOOP_HH

class TArtEventStore;
class TThread;
class TObject;
class TDirectory;

class TArtAnaLoop;

//alias
void book(TArtAnaLoop* analoop, TString filename,
	  int eventnumber = -1, TDirectory* directory = 0);
void start();
void stop();
void end();
void anasta();

class TArtAnaLoopManager
{
  friend class TArtAnaLoop;

public:
  static TThread* Book(TArtAnaLoop* analoop, TString filename,
		       int eventnumber = -1, TDirectory* directory = 0);
  static void Start();
  static void Stop();
  static void End();
  static void AnaSta();

private:
  static TThread* fThread;

  enum EAnalysisState{INIT, RUNNING, SUSPENDED, END};
  static EAnalysisState kAnalysisState;

private:
  TArtAnaLoopManager(){;}
  virtual ~TArtAnaLoopManager();

  ClassDef(TArtAnaLoopManager,1);
};

class TArtAnaLoopStatic
{
public:
  static void* AnaLoopStatic(void *);

  static void SetAnaLoop(TArtAnaLoop* analoop);
  static void SetFileName(TString filename);
  static void SetEventNumber(int eventnumber);
  static void SetDirectory(TDirectory* directory);

  static TArtAnaLoop* GetAnaLoop();
  static TString GetFileName();
  static int GetEventNumber();
  static TDirectory* GetDirectory();

 private:
   static TArtAnaLoop* fAnaLoop;
   static TString fFileName;
   static int fEventNumber;

  static TDirectory* fDirectory;

private:
  TArtAnaLoopStatic(){;}
  virtual ~TArtAnaLoopStatic(){;}

  ClassDef(TArtAnaLoopStatic,1);
};

class TArtAnaLoop
{
public:
  TArtAnaLoop();
  virtual ~TArtAnaLoop();

  virtual void AnaLoop(const char* filename, int eventnumber = -1);
  virtual const char* ClassName() const = 0;
  virtual int GetEventNumber() const {return neve;}

protected:
  virtual void Construct() = 0;
  virtual void Calculate() = 0;
  virtual void SuspendAction(){;}
  virtual void Destruct() = 0;

private:
  TArtEventStore *estore;
  int neve;
};

#endif
