#ifndef _TARTDALINAI_H_
#define _TARTDALINAI_H_

#include "TNamed.h"
#include "TString.h"

class TArtDALINaI: public TNamed {

 public:

  TArtDALINaI() {id=-1;fpl=-1;fADC=-1;fTDC=-1;layer=-1;fEnergy=-1;fDoppCorEnergy=-1;fTime=-1;}
  virtual ~TArtDALINaI(){}

  virtual void SetID(int val){id = val;}
  virtual void SetFpl(int val){fpl = val;}
  virtual void SetDetectorName(TString val){name = val;}
  virtual void SetLayer(int val){layer = val;}
  virtual void SetTheta(Double_t val){costheta = val;}

  virtual int  GetID(){return id;}
  virtual int  GetFpl(){return fpl;}
  virtual TString * GetDetectorName(){return &name;}
  virtual int  GetLayer(){return layer;}
  virtual Double_t  GetTheta(){return costheta;}

  // function to set raw data
  virtual void  SetRawADC(unsigned int val){fADC = val;}
  virtual void  SetRawTDC(unsigned int val){fTDC = val;}

  // function to get raw data
  virtual unsigned int GetRawADC(){return fADC;}
  virtual unsigned int GetRawTDC(){return fTDC;}

  // function to set reco data
  virtual void  SetEnergy(Double_t val){fEnergy = val;}
  virtual void  SetDoppCorEnergy(Double_t val){fDoppCorEnergy = val;}
  virtual void  SetTime(Double_t val){fTime = val;}

  // function to get reco data
  virtual Double_t GetEnergy(){return fEnergy;}
  virtual Double_t GetDoppCorEnergy(){return fDoppCorEnergy;}
  virtual Double_t GetTime(){return fTime;}

 private:

  int id;
  int fpl;
  TString name;

  unsigned int fADC;  
  unsigned int fTDC;  

  int layer;  
  Double_t costheta; // cos angle of nai

  Double_t fEnergy;  
  Double_t fDoppCorEnergy;  
  Double_t fTime;  


  ClassDef(TArtDALINaI,1);

};
#endif
